#include <bits/stdc++.h>
#define maxn 20000005
#define maxm 100005
#define mod 998244353
using namespace std;

int n,m;
long long a[maxn];
long long b[maxm]; 
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	cin>>n>>m;
	for(int i=1;i<=m;i++)cin>>b[i];
	for(int i=1;i<=n;i++)a[i]=i;
	
	for(int i=0;i<=n-m;i++)
		for(int j=1;j<=m;j++)
			a[i+b[j]]=a[i+j];
			
	long long x;x+=mod;x%=mod;
	cin>>x;
	long long ste=x;
	long long sol=0LL;
	for(int i=1;i<=n;i++)
	{
		long long dod=ste*a[i];dod%=mod;
		sol+=dod;sol%=mod;
		ste*=x;ste%=mod;
	}
	
	cout<<sol<<endl;
	return 0;
}